import { __awaiter, __generator } from 'tslib';
import { EventEmitter, Component, Input, Output, Directive, HostListener, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function MyWindow() { }
if (false) {
    /** @type {?} */
    MyWindow.prototype.PaystackPop;
}
var Angular4PaystackComponent = /** @class */ (function () {
    function Angular4PaystackComponent() {
        this.paymentInit = new EventEmitter();
        this.close = new EventEmitter();
        this.callback = new EventEmitter();
        this.isPaying = false;
    }
    /**
     * @return {?}
     */
    Angular4PaystackComponent.prototype.pay = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var payment;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.checkInput()) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.loadScript()];
                    case 1:
                        _a.sent();
                        this.setUp();
                        if (this.isPaying) {
                            return [2 /*return*/];
                        }
                        if (this.paymentInit.observers.length) {
                            this.paymentInit.emit();
                        }
                        payment = window.PaystackPop.setup(this.paystackOptions);
                        payment.openIframe();
                        this.isPaying = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    Angular4PaystackComponent.prototype.checkInput = /**
     * @return {?}
     */
    function () {
        if (!this.key) {
            return console.error('ANGULAR-PAYSTACK: Paystack key cannot be empty');
        }
        if (!this.email) {
            return console.error('ANGULAR-PAYSTACK: Paystack email cannot be empty');
        }
        if (!this.amount) {
            return console.error('ANGULAR-PAYSTACK: Paystack amount cannot be empty');
        }
        if (!this.ref) {
            return console.error('ANGULAR-PAYSTACK: Paystack ref cannot be empty');
        }
        if (!this.callback.observers.length) {
            return console.error("ANGULAR-PAYSTACK: Insert a callback output like so (callback)='PaymentComplete($event)' to check payment status");
        }
        return true;
    };
    /**
     * @return {?}
     */
    Angular4PaystackComponent.prototype.setUp = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.paystackOptions = {
            key: this.key,
            email: this.email,
            amount: this.amount,
            ref: this.ref,
            metadata: this.metadata || {},
            currency: this.currency || 'NGN',
            plan: this.plan || '',
            channels: this.channels,
            quantity: this.quantity || '',
            subaccount: this.subaccount || '',
            transaction_charge: this.transaction_charge || 0,
            bearer: this.bearer || '',
            callback: (/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                _this.isPaying = false;
                _this.callback.emit(res);
            }),
            onClose: (/**
             * @return {?}
             */
            function () {
                _this.isPaying = false;
                _this.close.emit();
            }),
        };
    };
    /**
     * @return {?}
     */
    Angular4PaystackComponent.prototype.loadScript = /**
     * @return {?}
     */
    function () {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            if (window.PaystackPop && typeof window.PaystackPop.setup === 'function') {
                resolve();
                return;
            }
            /** @type {?} */
            var script = window.document.createElement('script');
            window.document.head.appendChild(script);
            /** @type {?} */
            var onLoadFunc = (/**
             * @return {?}
             */
            function () {
                script.removeEventListener('load', onLoadFunc);
                resolve();
            });
            script.addEventListener('load', onLoadFunc);
            script.setAttribute('src', 'https://js.paystack.co/v1/inline.js');
        }));
    };
    /**
     * @return {?}
     */
    Angular4PaystackComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        this.setUp();
    };
    /**
     * @return {?}
     */
    Angular4PaystackComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.text) {
            console.error('Paystack Text input is deprecated. Add text into textnode like so <angular4-paystack>Pay With Paystack</angular4-paystack>');
        }
    };
    Angular4PaystackComponent.decorators = [
        { type: Component, args: [{
                    selector: 'angular4-paystack',
                    template: "<button [ngClass]=\"class\" [ngStyle]=\"style\" (click)=\"pay()\">{{text}}<ng-content></ng-content></button>"
                }] }
    ];
    /** @nocollapse */
    Angular4PaystackComponent.ctorParameters = function () { return []; };
    Angular4PaystackComponent.propDecorators = {
        text: [{ type: Input }],
        key: [{ type: Input }],
        email: [{ type: Input }],
        amount: [{ type: Input }],
        metadata: [{ type: Input }],
        ref: [{ type: Input }],
        currency: [{ type: Input }],
        plan: [{ type: Input }],
        quantity: [{ type: Input }],
        channels: [{ type: Input }],
        subaccount: [{ type: Input }],
        transaction_charge: [{ type: Input }],
        bearer: [{ type: Input }],
        class: [{ type: Input }],
        style: [{ type: Input }],
        paymentInit: [{ type: Output }],
        close: [{ type: Output }],
        callback: [{ type: Output }]
    };
    return Angular4PaystackComponent;
}());
if (false) {
    /** @type {?} */
    Angular4PaystackComponent.prototype.text;
    /** @type {?} */
    Angular4PaystackComponent.prototype.key;
    /** @type {?} */
    Angular4PaystackComponent.prototype.email;
    /** @type {?} */
    Angular4PaystackComponent.prototype.amount;
    /** @type {?} */
    Angular4PaystackComponent.prototype.metadata;
    /** @type {?} */
    Angular4PaystackComponent.prototype.ref;
    /** @type {?} */
    Angular4PaystackComponent.prototype.currency;
    /** @type {?} */
    Angular4PaystackComponent.prototype.plan;
    /** @type {?} */
    Angular4PaystackComponent.prototype.quantity;
    /** @type {?} */
    Angular4PaystackComponent.prototype.channels;
    /** @type {?} */
    Angular4PaystackComponent.prototype.subaccount;
    /** @type {?} */
    Angular4PaystackComponent.prototype.transaction_charge;
    /** @type {?} */
    Angular4PaystackComponent.prototype.bearer;
    /** @type {?} */
    Angular4PaystackComponent.prototype.class;
    /** @type {?} */
    Angular4PaystackComponent.prototype.style;
    /** @type {?} */
    Angular4PaystackComponent.prototype.paymentInit;
    /** @type {?} */
    Angular4PaystackComponent.prototype.close;
    /** @type {?} */
    Angular4PaystackComponent.prototype.callback;
    /**
     * @type {?}
     * @private
     */
    Angular4PaystackComponent.prototype.paystackOptions;
    /**
     * @type {?}
     * @private
     */
    Angular4PaystackComponent.prototype.isPaying;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function MyWindow$1() { }
if (false) {
    /** @type {?} */
    MyWindow$1.prototype.PaystackPop;
}
var Angular4PaystackDirective = /** @class */ (function () {
    function Angular4PaystackDirective() {
        this.close = new EventEmitter();
        this.callback = new EventEmitter();
        this.isPaying = false;
        this.setUp();
    }
    /**
     * @return {?}
     */
    Angular4PaystackDirective.prototype.pay = /**
     * @return {?}
     */
    function () {
        this.setUp();
        if (!this.checkInput()) {
            return;
        }
        /** @type {?} */
        var payment = window.PaystackPop.setup(this.paystackOptions);
        payment.openIframe();
        this.isPaying = true;
    };
    /**
     * @return {?}
     */
    Angular4PaystackDirective.prototype.checkInput = /**
     * @return {?}
     */
    function () {
        if (!this.key) {
            return console.error('ANGULAR-PAYSTACK: Paystack key cannot be empty');
        }
        if (!this.email) {
            return console.error('ANGULAR-PAYSTACK: Paystack email cannot be empty');
        }
        if (!this.amount) {
            return console.error('ANGULAR-PAYSTACK: Paystack amount cannot be empty');
        }
        if (!this.ref) {
            return console.error('ANGULAR-PAYSTACK: Paystack ref cannot be empty');
        }
        if (!this.callback.observers.length) {
            return console.error("ANGULAR-PAYSTACK: Insert a callback output like so (callback)='PaymentComplete($event)' to check payment status");
        }
        return true;
    };
    /**
     * @return {?}
     */
    Angular4PaystackDirective.prototype.setUp = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.paystackOptions = {
            key: this.key,
            email: this.email,
            amount: this.amount,
            ref: this.ref,
            metadata: this.metadata || {},
            currency: this.currency || 'NGN',
            plan: this.plan || '',
            quantity: this.quantity || '',
            subaccount: this.subaccount || '',
            channels: this.channels,
            transaction_charge: this.transaction_charge || 0,
            bearer: this.bearer || '',
            callback: (/**
             * @param {?} res
             * @return {?}
             */
            function (res) {
                _this.isPaying = false;
                _this.callback.emit(res);
            }),
            onClose: (/**
             * @return {?}
             */
            function () {
                _this.isPaying = false;
                _this.close.emit();
            })
        };
    };
    /**
     * @return {?}
     */
    Angular4PaystackDirective.prototype.loadScript = /**
     * @return {?}
     */
    function () {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            if (window.PaystackPop && typeof window.PaystackPop.setup === 'function') {
                resolve();
                return;
            }
            /** @type {?} */
            var script = window.document.createElement('script');
            window.document.head.appendChild(script);
            /** @type {?} */
            var onLoadFunc = (/**
             * @return {?}
             */
            function () {
                script.removeEventListener('load', onLoadFunc);
                resolve();
            });
            script.addEventListener('load', onLoadFunc);
            script.setAttribute('src', 'https://js.paystack.co/v1/inline.js');
        }));
    };
    /**
     * @return {?}
     */
    Angular4PaystackDirective.prototype.buttonClick = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isPaying) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.loadScript()];
                    case 1:
                        _a.sent();
                        this.pay();
                        return [2 /*return*/];
                }
            });
        });
    };
    Angular4PaystackDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[angular4-paystack]',
                },] }
    ];
    /** @nocollapse */
    Angular4PaystackDirective.ctorParameters = function () { return []; };
    Angular4PaystackDirective.propDecorators = {
        text: [{ type: Input }],
        key: [{ type: Input }],
        email: [{ type: Input }],
        amount: [{ type: Input }],
        metadata: [{ type: Input }],
        ref: [{ type: Input }],
        currency: [{ type: Input }],
        plan: [{ type: Input }],
        quantity: [{ type: Input }],
        subaccount: [{ type: Input }],
        channels: [{ type: Input }],
        transaction_charge: [{ type: Input }],
        bearer: [{ type: Input }],
        class: [{ type: Input }],
        style: [{ type: Input }],
        close: [{ type: Output }],
        callback: [{ type: Output }],
        buttonClick: [{ type: HostListener, args: ['click',] }]
    };
    return Angular4PaystackDirective;
}());
if (false) {
    /** @type {?} */
    Angular4PaystackDirective.prototype.text;
    /** @type {?} */
    Angular4PaystackDirective.prototype.key;
    /** @type {?} */
    Angular4PaystackDirective.prototype.email;
    /** @type {?} */
    Angular4PaystackDirective.prototype.amount;
    /** @type {?} */
    Angular4PaystackDirective.prototype.metadata;
    /** @type {?} */
    Angular4PaystackDirective.prototype.ref;
    /** @type {?} */
    Angular4PaystackDirective.prototype.currency;
    /** @type {?} */
    Angular4PaystackDirective.prototype.plan;
    /** @type {?} */
    Angular4PaystackDirective.prototype.quantity;
    /** @type {?} */
    Angular4PaystackDirective.prototype.subaccount;
    /** @type {?} */
    Angular4PaystackDirective.prototype.channels;
    /** @type {?} */
    Angular4PaystackDirective.prototype.transaction_charge;
    /** @type {?} */
    Angular4PaystackDirective.prototype.bearer;
    /** @type {?} */
    Angular4PaystackDirective.prototype.class;
    /** @type {?} */
    Angular4PaystackDirective.prototype.style;
    /** @type {?} */
    Angular4PaystackDirective.prototype.close;
    /** @type {?} */
    Angular4PaystackDirective.prototype.callback;
    /**
     * @type {?}
     * @private
     */
    Angular4PaystackDirective.prototype.paystackOptions;
    /**
     * @type {?}
     * @private
     */
    Angular4PaystackDirective.prototype.isPaying;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function MyWindow$2() { }
if (false) {
    /** @type {?} */
    MyWindow$2.prototype.PaystackPop;
}
var Angular4PaystackEmbed = /** @class */ (function () {
    function Angular4PaystackEmbed() {
        this.paymentInit = new EventEmitter();
        this.close = new EventEmitter();
        this.callback = new EventEmitter();
    }
    /**
     * @return {?}
     */
    Angular4PaystackEmbed.prototype.pay = /**
     * @return {?}
     */
    function () {
        if (!this.checkInput()) {
            return;
        }
        this.setUp();
        if (this.paymentInit.observers.length) {
            this.paymentInit.emit();
        }
        window.PaystackPop.setup(this.paystackOptions);
    };
    /**
     * @return {?}
     */
    Angular4PaystackEmbed.prototype.checkInput = /**
     * @return {?}
     */
    function () {
        if (!this.key) {
            return console.error('ANGULAR-PAYSTACK: Paystack key cannot be empty');
        }
        if (!this.email) {
            return console.error('ANGULAR-PAYSTACK: Paystack email cannot be empty');
        }
        if (!this.amount) {
            return console.error('ANGULAR-PAYSTACK: Paystack amount cannot be empty');
        }
        if (!this.ref) {
            return console.error('ANGULAR-PAYSTACK: Paystack ref cannot be empty');
        }
        if (!this.callback.observers.length) {
            return console.error("\n        ANGULAR-PAYSTACK: Insert a callback output like so (callback)='PaymentComplete($event)' to check payment status\n      ");
        }
        return true;
    };
    /**
     * @return {?}
     */
    Angular4PaystackEmbed.prototype.setUp = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.paystackOptions = {
            container: 'paystackEmbedContainer',
            key: this.key,
            email: this.email,
            amount: this.amount,
            ref: this.ref,
            metadata: this.metadata || {},
            currency: this.currency || 'NGN',
            plan: this.plan || '',
            quantity: this.quantity || '',
            subaccount: this.subaccount || '',
            channels: this.channels,
            transaction_charge: this.transaction_charge || 0,
            bearer: this.bearer || '',
            callback: (/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return _this.callback.emit(res); }),
            onClose: (/**
             * @return {?}
             */
            function () { return _this.close && _this.close.emit(); }),
        };
    };
    /**
     * @return {?}
     */
    Angular4PaystackEmbed.prototype.loadScript = /**
     * @return {?}
     */
    function () {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            if (window.PaystackPop && typeof window.PaystackPop.setup === 'function') {
                resolve();
                return;
            }
            /** @type {?} */
            var script = window.document.createElement('script');
            window.document.head.appendChild(script);
            /** @type {?} */
            var onLoadFunc = (/**
             * @return {?}
             */
            function () {
                script.removeEventListener('load', onLoadFunc);
                resolve();
            });
            script.addEventListener('load', onLoadFunc);
            script.setAttribute('src', 'https://js.paystack.co/v1/inline.js');
        }));
    };
    /**
     * @return {?}
     */
    Angular4PaystackEmbed.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadScript()];
                    case 1:
                        _a.sent();
                        if (this.text) {
                            console.error('ANGULAR-PAYSTACK: Paystack Text input is deprecated. Use this instead <angular4-paystack>Pay With Paystack</angular4-paystack>');
                        }
                        this.pay();
                        return [2 /*return*/];
                }
            });
        });
    };
    Angular4PaystackEmbed.decorators = [
        { type: Component, args: [{
                    selector: 'angular4-paystack-embed',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: "<div id=\"paystackEmbedContainer\"></div>"
                }] }
    ];
    /** @nocollapse */
    Angular4PaystackEmbed.ctorParameters = function () { return []; };
    Angular4PaystackEmbed.propDecorators = {
        text: [{ type: Input }],
        key: [{ type: Input }],
        email: [{ type: Input }],
        amount: [{ type: Input }],
        metadata: [{ type: Input }],
        channels: [{ type: Input }],
        ref: [{ type: Input }],
        currency: [{ type: Input }],
        plan: [{ type: Input }],
        quantity: [{ type: Input }],
        subaccount: [{ type: Input }],
        transaction_charge: [{ type: Input }],
        bearer: [{ type: Input }],
        paymentInit: [{ type: Output }],
        close: [{ type: Output }],
        callback: [{ type: Output }]
    };
    return Angular4PaystackEmbed;
}());
if (false) {
    /** @type {?} */
    Angular4PaystackEmbed.prototype.text;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.key;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.email;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.amount;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.metadata;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.channels;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.ref;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.currency;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.plan;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.quantity;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.subaccount;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.transaction_charge;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.bearer;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.paymentInit;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.close;
    /** @type {?} */
    Angular4PaystackEmbed.prototype.callback;
    /**
     * @type {?}
     * @private
     */
    Angular4PaystackEmbed.prototype.paystackOptions;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Angular4PaystackModule = /** @class */ (function () {
    function Angular4PaystackModule() {
    }
    Angular4PaystackModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [Angular4PaystackComponent, Angular4PaystackDirective, Angular4PaystackEmbed],
                    declarations: [Angular4PaystackComponent, Angular4PaystackDirective, Angular4PaystackEmbed],
                    providers: [],
                },] }
    ];
    return Angular4PaystackModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Angular4PaystackComponent, Angular4PaystackDirective, Angular4PaystackEmbed, Angular4PaystackModule };
//# sourceMappingURL=angular4-paystack.js.map
